package weaver.interfaces.hostar.job;

import com.engine.kq.biz.KQGroupComInfo;
import com.engine.kq.biz.KQOvertimeRulesBiz;
import com.engine.kq.biz.KQWorkTime;
import com.engine.kq.entity.WorkTimeEntity;
import org.apache.tools.ant.util.DateUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;
import java.time.format.DateTimeFormatter;
import java.util.*;

public class AutoSchedulJob extends BaseCronJob {

    private String fromDate;
    private String toDate;

    public String getFromDate() {
        return fromDate;
    }

    public String getToDate() {
        return toDate;
    }

    public void setFromDate(String fromDate) {
        this.fromDate = fromDate;
    }

    public void setToDate(String toDate) {
        this.toDate = toDate;
    }
    BaseBean bb= new BaseBean();

    @Override
    public void execute() {
        bb.writeLog("AutoSchedulJob Start");
        try {
            DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
            DateTimeFormatter formatter2 = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

            bb.writeLog("fromDate: " + fromDate);
            bb.writeLog("toDate: " + toDate);

            //当前日期
            toDate = DateUtils.format(new Date(), "yyyy-MM-dd");

            RecordSet rs = new RecordSet();
            boolean b = false;
            //查询所有考勤人员（去除人员）
            List<String> userList = new ArrayList<>();
            rs.executeQuery("select id from hrmresource where 1=1");
            while (rs.next()){
                userList.add(Util.null2String(rs.getString("id")));
            }
            bb.writeLog("AutoSchedulJob.userList: " + userList);

            String sql = "insert into kq_shiftschedule(kqdate,serialid,resourceid,groupid,isdelete)values(?,?,?,?,?)";
            String sql3 = "select currentnodetype from workflow_requestbase where requestid in (select requestid from kq_flow_split_leave where  " +
                    " resourceid = ? and (fromdatedb +' '+ fromtimedb) <=? and (todatedb+' '+totimedb) >=?) and currentnodetype = '3' ";
            //休息日默认排休息班
            for (String userId : userList) {
                WorkTimeEntity workTimeEntity = new KQWorkTime().getWorkTime(userId, toDate);
                /*获取考勤组的ID，因为考勤组有有效期，所以需要传入日期*/
                //String groupId = new KQGroupMemberComInfo().getKQGroupId(userId, toDate);
                int changeType = KQOvertimeRulesBiz.getChangeType(userId, toDate);
                //无需考勤人员
                String excludecount = Util.null2String(new KQGroupComInfo().getExcludecount(workTimeEntity.getGroupId()));//是否参与考勤报表统计
                if(workTimeEntity.getIsExclude()&&!excludecount.equals("1")){
                    continue;
                }
                if(changeType!=2){
                    //休息班
                     b = rs.executeUpdate(sql, toDate, "-1", userId, workTimeEntity.getGroupId(), "0");
                }else{
                    //查询该员工当天是否有已办结的请假流程（有：自动对班；否：不处理）
                    //6.2 查询这些requestid是否在当天前（包含当天）已批准
                    rs.executeQuery(sql3,userId,toDate,toDate);
                    if(rs.next()){
                        b = rs.executeUpdate(sql, toDate, "9", userId, workTimeEntity.getGroupId(), "0");
                    }
                }
            }
            bb.writeLog("AutoSchedulJob.b: " + b);
        }catch (Exception e) {
            bb.writeLog("AutoSchedulJob Exception: " + e);
        }
    }

}
